// rpn.bas
// change infix to postfix (Reverse Polish Notation)
// operators +, -
// See Compilers, Principles, Techniques and Tools (the Dragon book)
// chapter 2.5

// ./basico04 <rpn.bas >rpn.s
// cc -o rpn rpn.s

var lookahead: int

func main(): void
begin
  lookahead = getchar()
  expr()
  putchar('\n')
end

func expr(): void
begin
  term()
  while 1 do
    if lookahead = '+' then
      match('+'); term(); putchar('+')
    else if lookahead = '-' then
      match('-'); term(); putchar('-')
    else; break; endif; endif
  wend
end

func term(): void
begin
  if isdigit(lookahead) then
    putchar(lookahead)
    match(lookahead)
  else; error(); endif
end

func match(t: int): void
begin
  if lookahead = t then
    lookahead = getchar()
  else; error(); endif
end

func error(): void
begin
  printf("syntax error\n")
  exit(1)
end
