// rpn3.bas
// change infix to postfix (Reverse Polish Notation)
// all Basico operators
// See Compilers, Principles, Techniques and Tools (the Dragon book)
// chapter 2.9

// ./basico05 <rpn3.bas >rpn3.s
// cc -o rpn3 rpn3.s

var lookahead: int

func main(): void
begin
  lookahead = getchar()
  expr()
  putchar('\n')
end

func expr(): void
begin
  addexpr()
  while 1 do
    if lookahead = '=' then
      match('='); addexpr(); putchar('=')
    else if lookahead = '#' then
      match('#'); addexpr(); putchar('#')
    else if lookahead = '<' then
      match('<'); addexpr(); putchar('<')
    else if lookahead = '>' then
      match('>'); addexpr(); putchar('>')
    else break; endif; endif; endif; endif
  wend
end

func addexpr(): void
begin
  term()
  while 1 do
    if lookahead = '+' then
      match('+'); term(); putchar('+')
    else if lookahead = '-' then
      match('-'); term(); putchar('-')
    else if lookahead = '|' then
      match('|'); term(); putchar('|')
    else if lookahead = '^' then
      match('^'); term(); putchar('^')
    else break; endif; endif; endif; endif
  wend
end

func term(): void
begin
  unaryfact();
  while 1 do
    if lookahead = '*' then
      match('*'); unaryfact(); putchar('*')
    else if lookahead = '/' then
      match('/'); unaryfact(); putchar('/')
    else if lookahead = '%' then
      match('%'); unaryfact(); putchar('%')
    else if lookahead = '&' then
      match('&'); unaryfact(); putchar('&')
    else break; endif; endif; endif; endif
  wend
end

func unaryfact(): void
begin
  if lookahead = '-' then
    match('-'); fact(); putchar('m')
  else if lookahead = '~' then
    match('~'); fact(); putchar('~')
  else fact(); endif; endif
end

func fact(): void
begin
  if lookahead = '(' then
    match('('); expr(); match(')')
  else if isdigit(lookahead) then
    putchar(lookahead); match(lookahead)
  else error(); endif; endif
end

func match(t: int): void
begin
  if lookahead = t then
    lookahead = getchar()
  else error(); endif
end

func error(): void
begin
  printf("syntax error\n")
  exit(1)
end
